## forge 0.1.0

=== DESCRIPTION ===
Package: forge
Type: Package
Title: Casting Values into Shape
Version: 0.1.0
Authors@R: c(
  person("Kevin", "Kuo", role = c("aut", "cre"), email = "kevin.kuo@rstudio.com",
  comment = c(ORCID = "0000-0001-7803-7901"))
  )
Description: Helper functions with a consistent interface to coerce and verify
    the types and shapes of values for input checking.
License: Apache License (>= 2.0)
Encoding: UTF-8
LazyData: true
Depends: R (>= 3.1.2)
Imports: rlang
RoxygenNote: 6.1.0
Suggests: testthat, covr
NeedsCompilation: no
Packaged: 2018-08-27 05:24:47 UTC; kevinykuo
Author: Kevin Kuo [aut, cre] (<https://orcid.org/0000-0001-7803-7901>)
Maintainer: Kevin Kuo <kevin.kuo@rstudio.com>
Repository: CRAN
Date/Publication: 2018-08-31 19:00:06 UTC
