=== debian/changelog ===
forge (0.9.2-2) unstable; urgency=medium

  * Cherry-pick upstream patch facilitating builds with system libraries.
    New patch 0003-Consistent-definition-of-USE_SYSTEM-flags-for-glbind.patch
  * Force use of system dependencies via the USE_SYSTEM flags.
    Reason: fixes FTBFS during reproducible builds
  * Add missing build dependency on OpenGL.
    Reason: fixes FTBFS on sparc64
  * Add support for the nodoc build profile.
  * Add patch fixing spelling errors reported by Lintian.
    New patch 0004-Fix-spelling-errors.patch

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 04 Jan 2017 20:42:05 +0000

forge (0.9.2-1) unstable; urgency=medium

  * Switch to git-dpm.
  * New upstream release.
  * Drop patch Fix-build-of-examples-with-the-system-cl2hpp.patch, applied
    upstream.
  * New patch No-version-queries-with-Git.patch, avoid spurious "git not
    found" entries in the build log when the documentation is generated.
  * Drop gbp configuration in favor of git-dpm
  * Upgrade packaging to debhelper 10
  * Use architecture.mk to query DEB_HOST_MULTIARCH
  * Cosmetic fixup of rules file

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 21 Dec 2016 19:29:03 +0000

forge (0.9.0-2) unstable; urgency=medium

  * Update patch queue.
    - Refresh Use-system-MathJax.patch.
    - New patch Fix-build-of-examples-with-the-system-cl2hpp.patch.
  * Add packaging testsuite.

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 06 Dec 2016 19:37:43 +0000

forge (0.9.0-1) unstable; urgency=low

  * Initial release. (Closes: #834723)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 14 Sep 2016 00:25:40 +0100
