=== debian/control ===
Source: forge
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 3.0),
               debhelper (>= 10),
               dpkg-dev (>= 1.17.14),
               libfontconfig1-dev,
               libfreeimage-dev,
               libfreetype6-dev,
               libgl1-mesa-dev | libgl-dev,
               libglbinding-dev,
               libglfw3-dev,
               libglm-dev
Build-Depends-Indep: doxygen <!nodoc>
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/forge.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/forge.git
Homepage: https://github.com/arrayfire/forge

Package: libforge0
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: high-performance OpenGL visualization
 A prototype of the OpenGL interop library that can be used with ArrayFire. The
 goal of Forge is to provide high performance OpenGL visualizations for C/C++
 applications that use CUDA/OpenCL.
 .
 This package provides the shared libraries.

Package: libforge-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libforge0 (= ${binary:Version})
Suggests: forge-doc <!nodoc>
Description: development files for forge
 A prototype of the OpenGL interop library that can be used with ArrayFire. The
 goal of Forge is to provide high performance OpenGL visualizations for C/C++
 applications that use CUDA/OpenCL.
 .
 This package provides the development files.

Package: forge-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Description: documentation for forge
 A prototype of the OpenGL interop library that can be used with ArrayFire. The
 goal of Forge is to provide high performance OpenGL visualizations for C/C++
 applications that use CUDA/OpenCL.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>
