=== debian/tests/control ===
Test-Command: cp -a CMakeModules examples/* $AUTOPKGTEST_TMP
 ; cd $AUTOPKGTEST_TMP
 ; mkdir build
 ; cd build
 ; cmake -DBUILD_EXAMPLES_CUDA=OFF -DBUILD_EXAMPLES_OPENCL=ON -DUSE_SYSTEM_CL2HPP=ON ..
 ; cmake --build .
Depends: @, cmake, g++ | c++-compiler, libfreeimage-dev, libgl1-mesa-dev | libgl-dev,
 ocl-icd-opencl-dev | opencl-dev, opencl-clhpp-headers
