=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -38,16 +38,12 @@
 ELSE(TARGET forge)
 
     SET_PROPERTY(GLOBAL PROPERTY USE_FOLDERS ON)
-    FIND_PACKAGE(FreeImage REQUIRED)
+    FIND_PACKAGE(Forge REQUIRED)
     FIND_PACKAGE(OpenGL REQUIRED)
-    FIND_PACKAGE(Forge REQUIRED)
 
     SET(X11_LIBS "")
 
-    INCLUDE_DIRECTORIES(
-        ${FORGE_INCLUDE_DIRS}
-        ${FREEIMAGE_INCLUDE_PATH}
-        )
+    INCLUDE_DIRECTORIES(${FORGE_INCLUDE_DIRS})
 
     # OS Definitions
     IF(UNIX)
@@ -96,11 +92,9 @@
     GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)
 
     IF(TARGET forge)
-        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
-            "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY}")
+        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge "")
     ELSE(TARGET forge)
-        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
-            "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};")
+        BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES} "${X11_LIBS};${OPENGL_gl_LIBRARY}")
     ENDIF()
 ENDFOREACH()
 
@@ -132,11 +126,10 @@
             GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)
 
             IF(TARGET forge)
-                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
-                    "${FREEIMAGE_LIBRARY};${CUDA_LIBRARIES}")
+                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge "${CUDA_LIBRARIES}")
             ELSE(TARGET forge)
                 BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
-                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};${CUDA_LIBRARIES}")
+                    "${X11_LIBS};${OPENGL_gl_LIBRARY};${CUDA_LIBRARIES}")
             ENDIF()
         ENDFOREACH()
     ELSE()
@@ -160,11 +153,10 @@
             GET_FILENAME_COMPONENT(DIR_NAME ${FULL_DIR_NAME} NAME)
 
             IF(TARGET forge)
-                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge
-                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${OpenCL_LIBRARIES}")
+                BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} forge "${OpenCL_LIBRARIES};${OPENGL_gl_LIBRARY}")
             ELSE(TARGET forge)
                 BUILD_EXAMPLE(${EXAMPLE} ${FILE} ${DIR_NAME} ${FORGE_LIBRARIES}
-                    "${FREEIMAGE_LIBRARY};${OPENGL_gl_LIBRARY};${X11_LIBS};${OpenCL_LIBRARIES}")
+                    "${X11_LIBS};${OPENGL_gl_LIBRARY};${OpenCL_LIBRARIES}")
             ENDIF()
         ENDFOREACH()
     ELSE()
