=== debian/changelog ===
forge (1.0.1-4) unstable; urgency=medium

  * Team upload.
  * [7dfab77] chore: Add salsa-ci.yml for CI integration
  * [f53ee97] fix: Fix FTBFS by addressing OpenGL errors. (Closes: #1090222)
  * [9cf0061] chore: Update patches series file

 -- Anton Gladky <gladk@debian.org>  Sat, 05 Jul 2025 19:45:38 +0200

forge (1.0.1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061943

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 09:07:21 +0000

forge (1.0.1-3) unstable; urgency=medium

  [ Gianfranco Costamagna ]
  * Team upload

  [ Timo Aaltonen ]
  * tests: Add allow-stderr to restrictions

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 09 Aug 2018 15:29:02 +0200

forge (1.0.1-2) unstable; urgency=medium

  * Upload to unstable
  * Team upload
  * Add -Wno-dev to tests, to avoid cmake warnings being sent to stderr
  * cherry-pick two upstream fixes for build failures (Closes: #888931):
    - debian/patches/63e4a2037e42c00554a26de2355d962f91a9ab20.patch:
    - debian/patches/befa265294fd9ff679dece7874c1de50fea97b25.patch:

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Jul 2018 11:58:54 +0200

forge (1.0.1-1) experimental; urgency=medium

  * Switch from git-dpm to gbp
  * New upstream version 1.0.1
  * Rebase the patch queue
    - Drop 0003-Consistent-definition-of-USE_SYSTEM-flags-for-glbind.patch,
      applied upstream
    - Refresh 0004-Fix-spelling-errors.patch
  * Build depends on Boost
  * Bump soversion to 1
  * Update copyright information

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 20 May 2017 14:16:39 +0100
