=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Uploaders: Ghislain Antony Vaillant <ghisvail@gmail.com>
 Section: libs
 Priority: optional
-Build-Depends: cmake (>= 3.0),
+Build-Depends: dpkg-dev (>= 1.22.5), cmake (>= 3.0),
                debhelper (>= 10),
                dpkg-dev (>= 1.17.14),
+               libboost-dev,
                libfontconfig1-dev,
                libfreeimage-dev,
                libfreetype6-dev,
@@ -19,7 +20,10 @@
 Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/forge.git
 Homepage: https://github.com/arrayfire/forge
 
-Package: libforge0
+Package: libforge1t64
+Provides: ${t64:Provides}
+Replaces: libforge1
+Breaks: libforge1 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends},
@@ -37,7 +41,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends: ${misc:Depends},
-         libforge0 (= ${binary:Version})
+         libforge1t64 (= ${binary:Version})
 Suggests: forge-doc <!nodoc>
 Description: development files for forge
  A prototype of the OpenGL interop library that can be used with ArrayFire. The
