=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILD_OPTIONS = -DBUILD_EXAMPLES=OFF \
		-DFG_INSTALL_CMAKE_DIR="lib/$(DEB_HOST_MULTIARCH)/cmake/Forge" \
		-DFG_INSTALL_LIB_DIR="lib/$(DEB_HOST_MULTIARCH)" \
		-DUSE_SYSTEM_FREETYPE=ON \
		-DUSE_SYSTEM_GLBINDING=ON \
		-DUSE_SYSTEM_GLM=ON

%:
	dh $@

override_dh_auto_configure-arch:
	dh_auto_configure -- $(BUILD_OPTIONS) \
		-DBUILD_DOCUMENTATION=OFF

override_dh_auto_configure-indep:
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	dh_auto_configure -- $(BUILD_OPTIONS) \
		-DBUILD_DOCUMENTATION=ON \
		-DFG_INSTALL_DOC_DIR="share/doc/forge-doc"
endif
