=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/forge-$1\.tar\.gz/ \
https://github.com/arrayfire/forge/tags .*/v?(\d\S*)\.tar\.gz
